# These are private, filter them
%define __noautoprov 'libAggregation\\.so\\.1(.*)|libClangbackendipc\\.so\\.1(.*)|libCPlusPlus\\.so\\.1(.*)|libExtensionSystem\\.so\\.1(.*)|libGLSL\\.so\\.1(.*)|libLanguageUtils\\.so\\.1(.*)|libModeling\\.so\\.1(.*)|libQmlDebug\\.so\\.1(.*)|libQmlEditorWidgets\\.so\\.1(.*)|libQmlJS\\.so\\.1(.*)|libQtcSsh\\.so\\.1(.*)|libSqlite\\.so\\.1(.*)|libTimeline\\.so\\.1(.*)|libUtils\\.so\\.1(.*)|libqbscore\\.so\\.1(.*)|libqbsqtprofilesetup\\.so\\.1(.*)|libzeroconf\\.so\\.1(.*)|devel\\((.*)|qml\\((.*)'
%define __noautoreq 'libAggregation\\.so\\.1(.*)|libClangbackendipc\\.so\\.1(.*)|libCPlusPlus\\.so\\.1(.*)|libExtensionSystem\\.so\\.1(.*)|libGLSL\\.so\\.1(.*)|libLanguageUtils\\.so\\.1(.*)|libModeling\\.so\\.1(.*)|libQmlDebug\\.so\\.1(.*)|libQmlEditorWidgets\\.so\\.1(.*)|libQmlJS\\.so\\.1(.*)|libQtcSsh\\.so\\.1(.*)|libSqlite\\.so\\.1(.*)|libTimeline\\.so\\.1(.*)|libUtils\\.so\\.1(.*)|libqbscore\\.so\\.1(.*)|libqbsqtprofilesetup\\.so\\.1(.*)|libzeroconf\\.so\\.1(.*)|devel\\((.*)|qml\\((.*)'

%bcond_without cppcheck

%define cppcheck_version 4.4.0

Summary:	Qt Creator is a lightweight, cross-platform IDE
Name:		qt-creator
Version:	4.4.1
Release:	1
License:	LGPLv2+ and MIT
Group:		Development/KDE and Qt
Url:		http://qt.digia.com/products/developer-tools
Source0:	http://download.qt-project.org/official_releases/qtcreator/%(echo %{version} |cut -d. -f1-2)/%{version}/qt-creator-opensource-src-%{version}.tar.xz
# https://github.com/OneMoreGres/qtc-cppcheck/releases
Source1:	qtc-cppcheck-%{cppcheck_version}.tar.gz
Source2:	Nokia-QtCreator.xml
Source10:	%{name}.rpmlintrc
Patch0:		qt-creator-4.2.1-linkage.patch
Patch1:		qt-creator-4.2.2-locale.patch
# Don't set LD_LIBRARY_PATH to /usr/lib[64]:
# 1. It makes no sense anyway
# 2. It adds issues when running Qt Creator with nVidia proprietary driver
Patch2:		qt-creator-4.4.1-ld.patch
# cppcheck plugin integration
Patch11:	qt-creator-4.3.0-qtc-cppcheck.patch
Patch12:	qtc-cppcheck-4.2.0-path.patch
Patch13:	qtc-cppcheck-4.4.0-dependencies.patch
BuildRequires:	qmake5
BuildRequires:	pkgconfig(Qt5Concurrent)
BuildRequires:	pkgconfig(Qt5Core)
BuildRequires:	pkgconfig(Qt5Declarative)
BuildRequires:	pkgconfig(Qt5Designer)
BuildRequires:	pkgconfig(Qt5DesignerComponents)
BuildRequires:	pkgconfig(Qt5Gui)
BuildRequires:	pkgconfig(Qt5Help)
BuildRequires:	pkgconfig(Qt5Network)
BuildRequires:	pkgconfig(Qt5PrintSupport)
BuildRequires:	pkgconfig(Qt5QuickWidgets)
BuildRequires:	pkgconfig(Qt5Sql)
BuildRequires:	pkgconfig(Qt5Svg)
BuildRequires:	pkgconfig(Qt5Test)
BuildRequires:	pkgconfig(Qt5WebKitWidgets)
BuildRequires:	pkgconfig(Qt5Widgets)
BuildRequires:	pkgconfig(Qt5X11Extras)
BuildRequires:	qt5-tools
BuildRequires:	qt5-linguist-tools
BuildRequires:	qdoc5
# Not for plugin files
Requires:	%{_lib}qt5declarative5
Requires:	qt5-qtcanvas3d-qml
Requires:	qt5-qtquickcontrols-qml
Requires:	qt5-qtquickcontrols2-qml
Requires:	qt5-qttranslations
%if %{with cppcheck}
Suggests:	cppcheck
%endif
Suggests:	gcc-c++
Suggests:	gdb
Suggests:	qbs
Suggests:	qt5-designer
Suggests:	qt5-assistant
Suggests:	qt5-devel
Suggests:	qt5-qml-tools
Suggests:	qt-creator-doc
Suggests:	pkgconfig(gl)
Suggests:	pkgconfig(Qt5Qml)
Suggests:	pkgconfig(Qt5Quick)
Suggests:	pkgconfig(Qt5QuickWidgets)
Requires:	%{name}-common
Provides:	%{name}-ui = %{EVRD}

%description
Qt Creator (previously known as Project Greenhouse) is a new, lightweight,
cross-platform integrated development environment (IDE) designed to make
development with the Qt application framework even faster and easier.

%pre
if [ "$1" == "2" -a -L %{_bindir}/qtcreator ]
then
	rm -f %{_bindir}/qtcreator
fi

%files
%doc README.md
%{_bindir}/qtcreator
%{_libdir}/qtcreator
%exclude %{_libdir}/qtcreator/plugins/qbs
%{_datadir}/qtcreator
%{_datadir}/applications/qtcreator.desktop
%{_datadir}/metainfo/org.qt-project.qtcreator.appdata.xml
%{_prefix}/libexec/qtcreator/buildoutputparser
%{_prefix}/libexec/qtcreator/cpaster
%{_prefix}/libexec/qtcreator/dmgbuild
%{_prefix}/libexec/qtcreator/qml2puppet
%{_prefix}/libexec/qtcreator/qtcreator_process_stub
%{_prefix}/libexec/qtcreator/qtpromaker
%{_prefix}/libexec/qtcreator/sdktool

#------------------------------------------------------------------------------

%package common
Summary:	Files used by both Qt Creator Qt4 and Qt Creator Qt5
Group:		Development/KDE and Qt
BuildArch:	noarch

%description common
Files used by both Qt Creator Qt4 and Qt Creator Qt5.

%files common
%{_iconsdir}/*/*/*/QtProject-qtcreator.png
%{_datadir}/mime/packages/*

#------------------------------------------------------------------------------

%package doc
Summary:	Qt Creator documentation
Group:		Development/KDE and Qt
Suggests:	qt5-doc

%description doc
Qt Creator documentation.

%files doc
%{_datadir}/doc/qtcreator/qbs.qch
%{_datadir}/doc/qtcreator/qtcreator.qch
%{_datadir}/doc/qtcreator/qtcreator-dev.qch
%{_datadir}/doc/qtcreator/qbs/
%{_datadir}/doc/qtcreator/qtcreator/
%{_datadir}/doc/qtcreator/qtcreator-dev/

#------------------------------------------------------------------------------

%package -n qbs
Summary:	Qt Build Suite is the next-generation build system using QML dialect
Group:		Development/KDE and Qt
Obsoletes:	qbs-examples < 1.2

%description -n qbs
QBS builds applications based on the information in a project file that you
specify in a QML dialect. Unlike cmake it doesn't generates makefiles.

%files -n qbs
%{_bindir}/qbs*
%{_libdir}/qtcreator/plugins/qbs
%{_prefix}/libexec/qtcreator/qbs_processlauncher

#------------------------------------------------------------------------------

%prep
%setup -qn %{name}-opensource-src-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%if %{with cppcheck}
%patch11 -p1
pushd src/plugins
tar -xf %{SOURCE1}
mv qtc-cppcheck-%{cppcheck_version} qtc-cppcheck
pushd qtc-cppcheck
%patch12 -p1
%patch13 -p1
popd
popd
%endif

%build
%global optflags %{optflags} -Wstrict-aliasing=0 -Wno-error=strict-overflow
%qmake_qt5 -r IDE_LIBRARY_BASENAME=%{_lib}
%make STRIP=/bin/true
%make docs

%install
# Install the Qt 5.x version
make install STRIP=/bin/true INSTALL_ROOT=%{buildroot}%{_prefix} install_docs

# Prevent "same build ID in nonidentical files" in all the binaries
pushd %{buildroot}%{_bindir}
for i in *; do
	if [ "$i" != "qtcreator" ]; then
		strip --strip-unneeded "$i"
	fi
done
popd

mkdir -p %{buildroot}%{_datadir}/mime/packages
install -m 0644 %{SOURCE2} %{buildroot}/%{_datadir}/mime/packages

# We have better version
rm -f %{buildroot}%{_datadir}/applications/org.qt-project.qtcreator.desktop

mkdir -p %{buildroot}%{_datadir}/applications
cat > %{buildroot}%{_datadir}/applications/qtcreator.desktop << EOF
[Desktop Entry]
Type=Application
Exec=%{_bindir}/qtcreator %%F
Name=Qt Creator
Name[ru]=Qt Creator
GenericName=Integrated Development Environment
GenericName[ru]=Интегрированная среда разработки
X-KDE-StartupNotify=true
Icon=QtProject-qtcreator
Terminal=false
Categories=Development;IDE;Qt;
MimeType=text/x-c++src;text/x-c++hdr;text/x-xsrc;application/x-designer;application/vnd.nokia.qt.qmakeprofile;application/vnd.nokia.xml.qt.resource;
InitialPreference=9
EOF


%changelog

* Tue Nov 28 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.4.1-1
- (3e0a772) New version 4.4.1, update files

* Fri Nov 24 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.3.1-5
- (e294277) Bump release

* Mon Nov 06 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.3.1-4
- (1dcea30) Bump release

* Wed Sep 20 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.3.1-3
- (601a48a) Bump release

* Wed Aug 23 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.3.1-2
- (928880d) Suggest pkgconfig(gl)

* Thu Aug 10 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.3.1-1
- (e12eb5b) New version 4.3.1

* Mon May 29 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.3.0-1
- (b164f6d) New version 4.3.0
- (b164f6d) Update files

* Wed May 03 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.2-5
- (b6cb600) Don't set LD_LIBRARY_PATH to /usr/lib[64]

* Wed May 03 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.2-4
- (1af4824) Require qt5-qtcanvas3d-qml and qt5-qtquickcontrols2-qml

* Tue May 02 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.2-3
- (ddda4cd) Use C for English locale
- (Andrey Bondrov: 482198d) Suggest more Qt5 development headers
- (Andrey Bondrov: 108c3e4) Require libqt5declarative5

* Fri Apr 28 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.2-2
- (da67f32) Don't expand %%F macro in desktop file into file.file

* Thu Apr 27 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.2-1
- (6ba9def) New version 4.2.2

* Sat Feb 04 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.1-2
- (2bbe4c2) MassBuild#1230: Increase release tag

* Thu Jan 26 2017 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.2.1-1
- (3f48290) New version 4.2.1

* Tue Oct 25 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.0.2-4
- (58190f5) Don't provide and require QML
- (Andrey Bondrov: 30adc67) MassBuild#1169: Increase release tag

* Mon Jun 20 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.0.2-3
- (95a67ef) Requires qt5-qttranslations

* Fri Jun 17 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.0.2-2
- (7b186f7) Filter more internal libraries from Requires and Provides

* Fri Jun 17 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 4.0.2-1
- (328460a) Move xml from .abf.yml to git
- (Andrey Bondrov: 73087ca) New version 4.0.2
- (Andrey Bondrov: 73087ca) New qtc-cppcheck version 4.0.0
- (Andrey Bondrov: 73087ca) Require qt5-qtquickcontrols-qml instead of qtquickcontrols-qml

* Fri Jun 17 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.6.1-2
- (c0e3200) Requires qtquickcontrols-qml

* Fri May 06 2016 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.6.1-1
- (f2a4144) New version 3.6.1

* Fri Dec 18 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.6.0-2
- (353c328) Update qtc-cppcheck to 3.6.0

* Tue Dec 15 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.6.0-1
- (6fd1f18) Some files were moved from /usr/bin to /usr/libexec/qtcreator
- (Andrey Bondrov: 023a7f6) New version 3.6.0
- (Andrey Bondrov: 023a7f6) Re-diff linkage patch

* Tue Oct 20 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.5.1-2
- (0a29960) Adjust GenericName in desktop file
- (Andrey Bondrov: 71ba2d7) Add Russian translation to desktop file

* Sun Oct 18 2015 Andrey Bondrov <andrey.bondrov@rosalab.ru> 3.5.1-1
- (474ac0d) Update files


